# This script will compile the binary and launch a job
# that will report the FLOPs of the kernel defined in
# src/kernel.f90 and make a plot.

function checkbinary(){
   if [ ! -f bin/elemental.x ];then
      echo 1
   else
      echo 0
   fi
   }

function job_status(){
    while  [ 1 -gt 0 ];do
       if [ $(bjobs $1 2>&1 | grep "not found" -c ) -gt 0 ];then
          echo -en "\033[1K\rJob not found yet"
       else
          if [  $(bjobs $1 | grep  "PEND" -c ) -gt 0 ];then
             echo -en "\033[1K\rJob waiting..."
          fi
          if [  $(bjobs $1 | grep  "RUN" -c ) -gt 0 ];then
             echo -en "\033[1K\rJob running..."
          fi
          if [  $(bjobs $1 | grep  "DONE" -c ) -gt 0 ];then
             echo -en "\033[1K\rJob finished..."
             return 0
          fi
       fi
       sleep 1
    done
}


# (Re)Compiling-----------------------------------------
echo -n "Compiling..."
utils/compile.sh &> /dev/null
if [ $(checkbinary) -eq 1 ];then
   echo "It did not compile well. Recompiling output..."
   echo
   utils/compile.sh 
   exit 1
else 
   echo -e "\033[1K\r\n\nCompiled!"
fi
#-------------------------------------------------------


#-------------------------------------------------------
#Measuring FlopsPerByte

FpB=$(python utils/FlopsPerByteInKernel.py src/kernels.f90)
echo
echo "The current kernel has a computational intensity of $FpB FlopsPerByte"
echo

# Launching test ---------------------------------------
echo "Launching experiment to queue"
echo
cd utils
JOBID=$(bsub < extrae.job | grep -e "<[0-9]*>" -o | grep [0-9]* -o)
echo "JOB ID is $JOBID"
cd ..

job_status $JOBID
display plot_$JOBID.png
#-------------------------------------------------------
